/**********************************************************************************************/
/* FBL_ArraySetIterator.h																	  */
/*                                                                       					  */
/* Foundation Base Library ( FBL )		                                   					  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002                                       					  */
/* All Rights Reserved.                                                 					  */
/**********************************************************************************************/

#ifndef __FBL_ArrayIterator_h
   #define __FBL_ArrayIterator_h

#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/FBL_SetIterator.h>
#	include <VSDK/FBL_ArraySet.h>
#else
#	include <FBL_SetIterator.h>
#	include <FBL_ArraySet.h>
#endif // VSDK_FRAMEWORK_STYLE

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
class FBL_ArraySet;


/**********************************************************************************************/
class FBL_ArraySetIterator : public FBL_SetIterator
{
	public://///////////////////////////////////////////////////////////////////////////////////

FBL_EXP							FBL_ArraySetIterator( void );
FBL_EXP							FBL_ArraySetIterator( const FBL_ArraySet& inSet );

FBL_EXP virtual					~FBL_ArraySetIterator( void );							

FBL_EXP	virtual ID_TYPE	 		operator* ( void ) const { return *pCurrentItem; }

FBL_EXP virtual bool			First( void );
FBL_EXP virtual bool			Last( void );
 	
FBL_EXP virtual bool			Next( void );	
FBL_EXP virtual bool			Prev( void );	

FBL_EXP virtual bool			GoTo( ulong inIndex );
		
		
		/* High level methods */

virtual ID_TYPE					FirstItem( void ) { 
									return FBL_ArraySetIterator::First() ? *pCurrentItem : 0; 
								}
								
virtual ID_TYPE					LastItem( void ){
									return FBL_ArraySetIterator::Last() ? *pCurrentItem : 0; 
								}
							
virtual ID_TYPE					NextItem( void ){
									return FBL_ArraySetIterator::Next() ? *pCurrentItem : 0; 
								}
								
virtual ID_TYPE					PrevItem( void ){
									return FBL_ArraySetIterator::Prev() ? *pCurrentItem : 0; 
								}

							
    protected://////////////////////////////////////////////////////////////////////////////////

const	FBL_ArraySet*			mSet;
		ID_TYPE*				pCurrentItem;
};


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif
